#include <grape.h>


/* grape-methode "display"
 *  
 * Call              : GRAPE(scene,"display")()
 * 
 * Parameters        : SCENE *scene
 *             
 * Description       : eine instance scene wird auf dem
 *                     standard-device ausgegeben.
 *                     (ohne segmentaufbau ).
 * 
 *
 * Keywords          : display
 *
 * Author            : martin rumpf
 *
 * Copyright (c) 1989     by Universitaet Bonn
 *                           Institut fuer Angewandte Mathematik
 *                           Sonderforschungsbereich 256
 *                           D-53115 Bonn
 */


SCENE *scene_display()
{
  SCENE *self;
  GRAPHICDEVICE *dev;
  MANAGER *mgr;
  SUPROP *suprop;
  
  MATRIX44 help;

  self = (SCENE *)START_METHOD(G_INSTANCE);

  mgr = (MANAGER *)GRAPE(Manager,"get-stdmgr")();
  dev = (GRAPHICDEVICE *)GRAPE(GraphicDevice,"get-stddev")();
  
  if(self->object) { 
    /* HACK FOR SOFTIMAGE */
    dev->message(31, (char *)self);

    /* to have std_surprops in SOFTIMAGE available *************
     * dev->attribute(G_MODE_GET,G_PATCH_SUPROP,&(suprop.suprop_dev));
     * dev->attribute(G_MODE_SET,G_PATCH_SUPROP,&(suprop.suprop_dev)); 
     ***********************************************************/
    
    if(self->matrix_flag != G_MATRIX_NONE) {
      dev->transform(G_MODE_GET,self->matrix_flag,help);
      dev->transform(G_MODE_PRE,self->matrix_flag,self->object_trans);
    }

    if(self->suprop) {
      suprop = (SUPROP *)GRAPE (Suprop, "new-instance")("scene disp suprop");
      /* hope that's ok. */
      suprop->enabled = self->suprop->enabled;
      GRAPE (suprop, "store")();
      GRAPE (self->suprop,"load")();
    }

    if (g_strempty (self->method_name))
      GRAPE(self->object,mgr->current_display_method)();
    else
      if(strcmp(self->method_name,"no-display"))
        GRAPE(self->object,self->method_name)();

    if(self->suprop) {
      GRAPE (suprop, "load")();
      GRAPE (suprop, "delete")();
    }
    if(self->matrix_flag != G_MATRIX_NONE)
      dev->transform(G_MODE_SET,self->matrix_flag,help);
  }
  
  if(self->next_scene) {
    dev->message(32, (char *)self);
    GRAPE(self->next_scene,"display")();
  }
  dev->message(33, (char *)self);
    
  END_METHOD(self);
}


