#include <grape.h>


/* grape-methode "switch-sync-send"
 *  
 * Call              : GRAPE(timescene,"switch-sync-send")()
 *                  
 * Parameters        : TIMESCENE *timescene
 *
 * Description       : timescene->sync = !timescene->sync
 *
 * Keywords          : switch-sync-send
 *
 * Author            : martin rumpf
 *
 * Copyright (c) 1992     by Universitaet Bonn
 *                           Institut fuer Angewandte Mathematik
 *                           Sonderforschungsbereich 256
 *                           D-53115 Bonn
 */

TIMESCENE *timescene_switch_sync_send()
{ 
  TIMESCENE *s;

  s = (TIMESCENE *)START_METHOD(G_INSTANCE);
  s->sync = (s->sync) ? 0 : 1;
  END_METHOD(s);
}

TIMESCENE *timescene_syncronize(t)
     double t;
{
  TIMESCENE *s;

  s = (TIMESCENE *)START_METHOD(G_INSTANCE);
  if(s->sync)
    s->time = t;
  if(s->next_scene != NULL)
    GRAPE(s->next_scene,"syncronize")(t);
    
  END_METHOD(s);
}
