/*
 * head file for grape project "rotate"
 *
 * Description       : Typedefs and defines for rotate.
 *
 * Author            : Bernd Oberknapp
 *
 * Copyright (c) 1995  by Universitaet Bonn
 *                        Institut fuer Angewandte Mathematik
 *                        Sonderforschungsbereich 256
 *                        D-53115 Bonn
 *
 * $Log:$
 */


/*
 * the structure for our new class, we use a #define to be able to
 * use the ROT2D_STRUCT in subclasses of Rot2d - just as we use the
 * TRIANG2D_STRUCT in this subclass of Triang2d
 */

#define ROT2D_STRUCT                                    \
  TRIANG2D_STRUCT;   /* the superclass is Triang2d */   \
  /* ROT2D */                                           \
  TRIANG1D *curve;   /* the curve that is rotated */    \
  TRIANG1D *axis;    /* axis for the rotation */        \
  double angle;      /* angle of the rotation */        \
  int discr;         /* number of segments to create */ \
  int current        /* current point for editing */

typedef struct {
  ROT2D_STRUCT;
} ROT2D;


/*
 * our new class declared in the main program
 */

extern CLASS *Rot2d; 


/*
 * prototypes for all methods
 */

ROT2D *rot2d_new_instance(char *);
ROT2D *rot2d_free(void);
ROT2D *rot2d_hardcopy(void);
ROT2D *rot2d_softcopy(ROT2D *);
ROT2D *rot2d_rotate_send(void);
ROT2D *rot2d_display(void);
ROT2D *rot2d_get_info(XLIST *);
ROT2D *rot2d_follow(INSTANCE *[3][3], char [3][3]);
ROT2D *rot2d_xdr(XDR *);

GROUP *rot2d_get_editor(void);
ROT2D *rot2d_update_point(void);
CLASS *rot2d_update_editor(INSTANCE *);

TRIANG1D *triang1d_insert_point(int);
ROT2D *rot2d_insert_point_send();
TRIANG1D *triang1d_delete_point(int);
ROT2D *rot2d_delete_point_send();
