/*
 * Default main program for grape
 *
 * Description       : Add all used-defined projects and call
 *                     handle on a Scene instance.
 *
 * Author            : Bernd Oberknapp
 *
 * Copyright (c) 1995  by Universitaet Bonn
 *                        Institut fuer Angewandte Mathematik
 *                        Sonderforschungsbereich 256
 *                        D-53115 Bonn
 *
 * $Log:$
 */

#include <grape.h>


/*
 * All functions used in the project list have to be declared.
 */
void *project_rotate_setup();


/*
 * List of user defined programs. Each entry consists of the
 * projects name, the name of the setup method, the pointer
 * to this method and a `hidden' flag. If the hidden flag is
 * not zero then the project will not be in the manager's
 * project list. The list has to be terminated by a null entry.
 */
static PRTYPE my_projects[] = {
  { "rotate", "rotate-setup", project_rotate_setup, 0 },

  { NULL, NULL, NULL, 0 }
};


int main()
{
  MANAGER *mgr;
  SCENE *scene;

  /*
   * Add all user defined projects to the system.
   */
  g_project_include(my_projects);

  /*
   * Get the manager and create a scene for handling.
   */
  mgr = (MANAGER *)GRAPE(Manager, "get-stdmgr")();
  scene = (SCENE *)GRAPE(Scene, "new-instance")("main");

  /*
   * Start the manager...
   */
  GRAPE(mgr, "handle")(scene);

  return 0;
}
